const { types: t } = require("@babel/core");

class BaseScript {
    body = [];

    setProperty(name, value) {
        let expressionStatement = t.expressionStatement(
            t.assignmentExpression(
                "=",
                t.memberExpression(
                    t.identifier("$scope"),
                    t.isIdentifier(name) ? name : t.identifier(name)
                ),
                value
            )
        );
        this.body.push(expressionStatement);
    }

    setMethod(name, params = [], body = t.blockStatement([])) {
        let expressionStatement = t.expressionStatement(
            t.assignmentExpression(
                "=",
                t.memberExpression(
                    t.identifier("$scope"),
                    t.isIdentifier(name) ? name : t.identifier(name)
                ),
                t.functionExpression(null, params, body)
            )
        );
        this.body.push(expressionStatement);
    }
}

module.exports = BaseScript;
