const { template, types: t } = require("@babel/core");
const BaseScript = require("./BaseScript");
const _ = require("underscore");

class Controller extends BaseScript {
    name = "";

    setName(name) {
        this.name = name;
    }

    setConstructor(body = []) {
        let ast = template("$scope.constructor = function() %%body%% ()")({
            body: body,
        });
        this.body.push(ast);
    }

    getAst() {
        return template(
            `module.controller(%%name%%, ["$scope", function($scope) %%body%%])`
        )({
            name: t.stringLiteral(this.name),
            body: this.body,
        });
    }
}

module.exports = Controller;
