const { ast2code } = require("../utils");
const BaseScript = require("./Script");
const ReactScript = require("../React/Script");
class Script extends BaseScript {
    constructor(ast, options = {}) {
        super(ast);
        this.reactScript = new ReactScript(ast);
        this.transformExtends();
        this.transformState();
    }

    transformState() {
        this.reactScript.setState();
    }

    transformExtends() {
        this.reactScript.setExtends();
    }

    getCode() {
        return ast2code(this.ast, true);
    }
}

module.exports = Script;
