const t = require("@babel/types");
const Path = require("../types/Path");

class ClassMethod extends Path {
    /**
     * 构造方法
     *
     * @param {Object} path 节点路径
     */
    constructor(path) {
        super(path);
    }

    /**
     * 获取方法的名称
     *
     * @returns {String} 方法名称
     */
    getName() {
        let name = false;
        if (t.isIdentifier(this.path.node.key)) {
            name = this.path.node.key.name;
        }
        return name;
    }

    /**
     * 获取方法的参数
     *
     * @returns {Array} 方法参数
     */
    getParams() {
        if (!this.path) {
            return;
        }
        return this.path.node.params;
    }

    /**
     * 获取方法的参数
     *
     * @returns {Array} 方法参数
     */
    getBody() {
        return this.path.node.body;
    }

    prepend(value) {
        this.node.body.body = value.concat(this.node.body.body);
    }

    /**
     * 获取返回值
     *
     * * @returns {Array} 方法参数
     */
    getReturns() {
        return;
    }

    getLeadingComments() {
        return this.node.leadingComments && this.node.leadingComments[0];
    }
}

module.exports = ClassMethod;
