const { types, Node } = require("@babel/core");

class JSXExpressionContainer {
    constructor(node) {
        this.node = node;
    }

    getExpression() {
        return this.node.expression;
    }

    getName() {
        if (types.isMemberExpression(this.getExpression())) {
            return this.getExpression().property.name;
        } else if (types.isCallExpression(this.getExpression())) {
            return this.getExpression().callee.property.name;
        }
    }
}

module.exports = JSXExpressionContainer;
